(function (interact) {

    'use strict';

    var transformProp;
    var farPoint;
    var edge1El, edge2El, columnEl;

    var robotIndex, moverIndex, printerIndex, rotateIndex, soundIndex, sensorIndex;
	var botLeft, botRight, botUp, botDown;//by Yim 2017/10/11
	var step1Index, step2Index, step3Index, step4Index, step5Index, step6Index, step7Index, step8Index;
	var node1Index, node2Index, node3Index, node4Index, node5Index, node6Index;
    robotIndex = moverIndex = printerIndex = rotateIndex = soundIndex = sensorIndex = 0;
	step1Index=step2Index=step3Index=step4Index=step5Index=step6Index=step7Index=step8Index=0;
	node1Index=node2Index=node3Index=node4Index=node5Index=node6Index=0;
	botLeft=botRight=botUp=botDown=0;//by Yim 2017/10/11

    interact.maxInteractions(Infinity);

    var docElem = window.document.documentElement;

    function scrollX() { return window.pageXOffset || docElem.scrollLeft; }
    function scrollY() { return window.pageYOffset || docElem.scrollTop; }
    function getOffset(el) {
        var offset = el.getBoundingClientRect();
        return { top : offset.top + scrollY(), left : offset.left + scrollX() };
    }

    function revertDraggable(el) {
        el.style.transform = el.style.webkitTransform = 'none';
        el.style.zIndex = 1;
        el.setAttribute('data-x', 0);
        el.setAttribute('data-y', 0);
    }

    function angle(cx, cy, ex, ey) {
      var dy = ey - cy;
      var dx = ex - cx;
      var theta = Math.atan2(dy, dx); // range (-PI, PI]
      theta *= 180 / Math.PI; // rads to degs, range (-180, 180]
      return theta;
    }
    function angle360(cx, cy, ex, ey) {
      var theta = angle(cx, cy, ex, ey); // range (-180, 180]
      if (theta < 0) theta = 360 + theta; // range [0, 360)
      return theta;
    }

    function getLength( cx, cy, ex, ey) {
        var deltaX = ex - cx;
        var deltaY = ey - cy;
        return Math.sqrt(Math.pow(deltaX,2) + Math.pow(deltaY,2));
    }

    function dragMoveListener (event) {
        var target = event.target,
        // keep the dragged position in the data-x/data-y attributes
        x = (parseFloat(target.getAttribute('data-x')) || 0) + event.dx,
        y = (parseFloat(target.getAttribute('data-y')) || 0) + event.dy;

		
        if( classie.has(target, 'drag-element--dropped') )
        {//  이놈은 리사이즈 가능한 넘이고... 이미 코딩맵에 드롭 된 넘이구만...
            if( target.id == 'edge1')   {
                       

                //rotate column
                var pt1 = getOffset(edge1El);

                //console.log( 'edge1 left = ' + pt1.left + ', top=' + pt1.top )
                              

                var columnAngle = angle360(pt1.left, pt1.top, farPoint.left, farPoint.top );
                //console.log( 'columnAngle =' + columnAngle );
                var originalAngle = 0;
                if( columnEl.getAttribute('angle') )
                {
                    originalAngle = columnEl.getAttribute('angle');
                }
                var rotateAngle = columnAngle - originalAngle;
                if(rotateAngle < 0) rotateAngle = 360 + rotateAngle;
                if(rotateAngle > 360) rotateAngle = rotateAngle - 360;

                //var colWidth = columnEl.clientWidth - event.dx;
                //if(colWidth < 50 ) colWidth = 50;

                //*
                columnEl.style.left = (x + 15) + 'px' ;   
                columnEl.style.top =  (y + 5 )  + 'px';      
//YIM                columnEl.style.top =  (y)  + 'px';      
                columnEl.style['-webkit-transform-origin'] =
                columnEl.style['transform-origin'] = '0% 50%';                        

                columnEl.style.webkitTransform =
                columnEl.style.transform =
                'rotate(' + columnAngle + 'deg)';

                columnEl.setAttribute('angle', columnAngle);
                
                columnEl.style.width = getLength(pt1.left , pt1.top, farPoint.left, farPoint.top ) + 'px';

                target.setAttribute('angle', rotateAngle); 
                target.parentNode.style.height = 0;
                target.parentNode.style.width = 0;

           }
            else if( target.id == 'edge2')
            {
                //rotate column...
                var pt1 = getOffset(edge2El);
                              

                var columnAngle = angle360(farPoint.left, farPoint.top, pt1.left, pt1.top );// angle360( x, y, edge2El.getAttribute('data-x'), edge2El.getAttribute('data-y'));

                var theta = rotateAngle * Math.PI / 180;
                columnEl.style.left = ((parseFloat(edge1El.getAttribute('data-x')) || 0) + 15  ) + 'px';// * (2 - Math.cos(theta)) ) + 'px' ;   
                columnEl.style.top =  ((parseFloat(edge1El.getAttribute('data-y')) || 0) + 5  ) + 'px' ;         
                columnEl.style['-webkit-transform-origin'] =
                columnEl.style['transform-origin'] = '0% 50%';                        
               
                columnEl.style.webkitTransform =
                columnEl.style.transform =
                'rotate(' + columnAngle + 'deg)';

                target.parentNode.style.height = 0;
                target.parentNode.style.width = 0;

                columnEl.setAttribute('angle', columnAngle);

                columnEl.style.width = getLength(pt1.left , pt1.top, farPoint.left, farPoint.top ) + 'px';


                target.setAttribute('angle', rotateAngle); 
            }
        }
            
        // translate the element
        target.style.webkitTransform =
        target.style.transform =
          'translate(' + x + 'px, ' + y + 'px)';

        // update the posiion attributes
        target.setAttribute('data-x', x);
        target.setAttribute('data-y', y);
    }

      // this is used later in the resizing and gesture demos
    window.dragMoveListener = dragMoveListener;

    var startPos = null;

    // target elements with the "draggable" class
    interact('.toolitem' )
		.draggable({
			onmove: dragMoveListener,
			// call this function on every dragend event
			onend: function (event) {
				//console.log('drag end event...');
				startPos = null;
				if( !classie.has(event.target, 'drag-element--dropped') )
				{
					revertDraggable(event.target);
				}
			}
		})

        .inertia(true)

		.snap({
			mode: 'anchor',
			anchors: [],
			range: 100,
			elementOrigin: { x: 0.5, y: 0.5 },
			endOnly: true
		})
        
        // enable autoScroll
        .autoScroll(true)

        // call this function on every dragmove event
        .on('dragstart', function (event) {
            //console.log('drag start event...');
            var target = event.target;
            //if( classie.has( target, 'resize-element'))
            //console.log( target );
            if( classie.has(target, 'drag-element--dropped') )
            {//  이놈은 리사이즈 가능한 넘이고... 이미 코딩맵에 드롭 된 넘이구만...
                //var edge1El, edge2El, columnEl;
                
                if( target.id == 'edge1')
                {
                    edge1El = target;
                    columnEl = getBrotherElement(target, 'column');
                    edge2El = getBrotherElement(target, 'edge2');         

                    //edge1El.style.zIndex = edge2El.style.zIndex = 20;
                    
                    farPoint = getOffset(edge2El);
                }
                else if( target.id == 'edge2' )
                {
                    edge2El = target;
                    columnEl = getBrotherElement(target, 'column');
                    edge1El = getBrotherElement(target, 'edge1');         
                    farPoint = getOffset(edge1El);
                }           
            }    

			//Added by Yim 2017/04/15 Start
			if (!startPos) {
			  var rect = interact.getElementRect(event.target);

			  // record center point when starting the very first a drag
			  startPos = {
				x: rect.left + rect.width  / 2,
				y: rect.top  + rect.height / 2
			  }
			}
			event.interactable.snap({ anchors: [startPos] });
			//Added by Yim 2017/04/15 End
		});


    function addElement(strTitle, strMsg, element) {
		
		
        var ni = document.getElementById('myDiv');
        var numi = document.getElementById('theValue');
        var num = (document.getElementById('theValue').value -1)+ 2;

        numi.value = num;
        var newdiv = document.createElement('div');
        var divIdName = 'my'+num+'Div';
        newdiv.setAttribute('id',divIdName);
        newdiv.setAttribute('class','dialog');
        newdiv.setAttribute('title',strTitle);
        newdiv.setAttribute('style', 'display:none;');
        newdiv.setAttribute('cache', 'false;');


        //newdiv.setAttribute('style', 'z-index:1000;');
        var direction = element.getAttribute('direction');

        var orientFront = "<input type='radio' name='direction' value='front'" ; 
        var orientLeft = "<input type='radio' name='direction' value='left'" ; 
        var orientRight = "<input type='radio' name='direction' value='right'" ; 

        if( direction == 'front' )          
            orientFront += "checked";
        else if (direction == 'left')
            orientLeft += "checked";
        else if( direction == 'right')
            orientRight += "checked";
 
        orientFront += '> 직진 ' ;
        orientLeft += '> 좌회전 ' ;
        orientRight += '> 우회전 ' ;

        

        var playLED = "<input type='checkbox' name='action' value='led'";//  " > 불 깜빡이기 <br> " ; 
        var playRound = "<input type='checkbox' name='action' value='rolling'";   //> 빙글빙글 돌기 <br> " ; 
        var playWatchOut = "<input type='checkbox' name='action' value='watchside'";   // > 왼쪽 오른쪽 살피기 <br> " ; 

        var bled = element.getAttribute('led') == 'led' ? ' checked> 불 깜빡이기 <br>' : '> 불 깜빡이기 <br>';
        var brolling = element.getAttribute('rolling') == 'rolling' ? ' checked > 빙글빙글 돌기 <br>' : '> 빙글빙글 돌기 <br>';
        var bwatchside = element.getAttribute('watchside') == 'watchside' ? ' checked> 왼쪽 오른쪽 살피기 <br>' : '> 왼쪽 오른쪽 살피기 <br>';

        //var innerhtml =  orientFront + orientLeft + orientRight + "<br><br> 동작설정 <br>" + playLED + playRound + playWatchOut ;//  "<input type='radio' name='direction' value='front'> 직진 <br>  <input type='radio' name='direction' value='left'> 좌회전 <br> <input type='radio' name='direction' value='right'> 우회전 <br>" + strMsg;
        var innerhtml =  "<br>" + playLED + bled + playRound + brolling + playWatchOut + bwatchside ;
        newdiv.innerHTML = innerhtml;// strMsg;//"Element Number ";//+num+" has been added! <a href=\'#\' onclick=removeElement('"+divIdName+"')>Remove the div "+divIdName+"</a>";
        ni.appendChild(newdiv);

        return divIdName;
    }

    function remove(id) {
		var list=document.getElementById(id);
		if(list) list.parentNode.removeChild(list);
    }

    function removeElement(divNum) {
      var d = document.getElementById(divNum);
      var olddiv = document.getElementById(divNum);
      d.removeChild(olddiv);
	}

    interact('.disp-dropped')
    .on('hold', function (event) {
/*
        var elementname = addElement("동작설정", "hold event...", event.target );
        $("#"+elementname).dialog({
                autoOpen: true,
                modal:true,
                buttons: {                  
                  "확인": function() {  

                        console.log("checked..." + $('input[name="action"]:checked').val() );
                        //if($("#playLED").checked   )

                        event.target.removeAttribute('led');
                        event.target.removeAttribute('rolling');
                        event.target.removeAttribute('watchside');

                        $('input[name="action"]:checked').each(function() {
                            var value = $(this).val();
                            event.target.setAttribute( value, value );
                            //console.log(test);
                        });

                       
                        //event.target.parentNode.setAttribute('direction',  $('input[name="direction"]:checked').val());

                        //console.log( 'direction = ' + event.target.getAttribute('direction') );     
                        $("#"+elementname).find("input").remove();                        
                        $("#"+elementname).dialog('destroy'); 
                        //$("#"+elementname).destroy().remove();

                        return false;
                    }
                },
                zindex:500
        });
*/
    });


    // setup drop areas.
    setupDropzone('.edgeanchor', '.toolitem');
    setupDropzone('.coding-map', '.toolitem');
    setupDropzone('.disp-delbox', '.toolitem');

   
    /**
     * Setup a given element as a dropzone.
     *
     * @param {HTMLElement|String} el
     * @param {String} accept
     */
    function setupDropzone(el, pname) {
        interact(el)
            .dropzone({
                accept: pname,
                ondropactivate: function (event) {
                    classie.add(event.relatedTarget, '-drop-possible');
                },
                ondropdeactivate: function (event) {
                    classie.remove(event.relatedTarget, '-drop-possible');
                }
            })
            .on('dropactivate', function (event) {
                var active = event.target.getAttribute('active')|0;

                
                // change style if it was previously not active
                if (active === 0) {
                    classie.add(event.target, '-drop-possible');

                    //event.target.textContent = 'Drop me here!';
                }

                event.target.setAttribute('active', active + 1);
            })
            .on('dropdeactivate', function (event) {
                var active = event.target.getAttribute('active')|0;

                //if( classie.has(event.target, 'edgeanchor') )
                //    classie.remove(event.relatedTarget, 'makeblack');
                //classie.remove(event.target, 'makeblack');

                // change style if it was previously active
                // but will no longer be active
                if (active === 1) {
                    classie.remove(event.target, '-drop-possible');
                    //event.target.textContent = 'Dropzone';
                }

                event.target.setAttribute('active', active - 1);
            })
            .on('dragenter', function (event) {
                classie.add(event.target, '-drop-over');
				
				var dropRect = interact.getElementRect(event.target),
					dropCenter = {
					  x: dropRect.left + dropRect.width  / 2,
					  y: dropRect.top  + dropRect.height / 2
					};

				event.draggable.snap({
				  anchors: [ dropCenter ]
				});
/*
				//Add by Yim 2017/04/19 Start
				var draggableElement = event.relatedTarget,
					dropzoneElement = event.target;

				// feedback the possibility of a drop
				dropzoneElement.classList.add('drop-target');
				draggableElement.classList.add('can-drop');
				//Add by Yim 2017/04/19 end
*/				
				// 이동막대를 옮길 때 엣지 2개의 검정색을 없앤다.
                if( classie.has(event.target, 'coding-map') && classie.has(event.relatedTarget, 'resize-element')){
					var children = event.relatedTarget.childNodes;
					var child;

					for(child in children){
						var childnode = children[child];
						var childid = childnode.id;
						if(childid=='edge1' || childid=='edge2'){
							classie.remove(childnode, 'makeblack');
							//엣지에 앵커정보가 있으면 앵커에서 무버아이디를 없애야한다.
							if(childnode.getAttribute('anchor-id')){
								//앵커 오브젝트를 불러온다.
								var anchor_object = document.getElementById(childnode.getAttribute('anchor-id'));
								//앵커 FG오브젝트 목록에서 엣지페어런트 이름과 같은 것을 삭제해 준다.
								for(var tempa=1;tempa<3;tempa++){
									if(childnode.parentNode.id == anchor_object.getAttribute('FG'+tempa)) anchor_object.removeAttribute('FG'+tempa);
								}	
							}								
							childnode.removeAttribute('anchor-id');	
						}
					}
				}
                //*/
                //event.relatedTarget.textContent = 'I\'m in';
            })
            .on('dragleave', function (event) {
				event.draggable.snap(false);
				// when leaving a dropzone, snap to the start position
				event.draggable.snap({ anchors: [startPos] });

				classie.remove(event.target, '-drop-over');

                if( classie.has(event.target, 'edgeanchor') ) {
                    classie.remove(event.relatedTarget, 'makeblack');
                    event.relatedTarget.removeAttribute('anchor-id'); // 엣지 앵커에서 나왔으니 앵커 아이디 속성을 지운다...
					// 엣지가 나가는 경우 페어런드 노드 값이 같은 곳을 지워준다
					// 아이콘이 나가는 경우 아이콘 링크값을 지워준다.
					if((event.relatedTarget.id=="edge1")||(event.relatedTarget.id=="edge2")){
						for(var tempa=1;tempa<3;tempa++){
							if(event.relatedTarget.parentNode.id == event.target.getAttribute('FG'+tempa)) event.target.removeAttribute('FG'+tempa);
						}
					}else{
						if(event.target.getAttribute('FIcon') == event.relatedTarget.id){
							event.target.removeAttribute('FIcon');
							//remove(event.target.getAttribute('FIcon'));
						}
					}

					var testG1 = event.target.getAttribute('FG1');
					var testG2 = event.target.getAttribute('FG2');

					//console.log('FG1='+testG1+'FG2='+testG2);
					//console.log( 'FIcon=' + event.target.getAttribute('FIcon') );
				}

                if( classie.has(event.target, 'disp-dropzone') ) {
                    classie.remove(event.relatedTarget, 'disp-dropped');
                    event.relatedTarget.removeAttribute('drop-on-mover');
                    event.relatedTarget.removeAttribute('drop-on-edge');
                }

                if(classie.has(event.relatedTarget, 'connector'))
                {
                 
                    classie.remove(event.target, 'makeblack');
                    classie.remove(event.relatedTarget, 'makeblack');

                    //console.log('remove black class...');
                }
				//console.log('Drag leave');
            })           
            .on('drop', function (event) {

                if( !classie.has(event.relatedTarget, 'drag-element--dropped') )
                {
                    //console.log('guest of first visit...');
                    classie.remove(event.target, '-drop-over');

                    var draggableElement = event.relatedTarget;
                    var clone = draggableElement.cloneNode(true);

					
                    var x = (parseFloat(draggableElement.getAttribute('data-x')) || 0) ,
                    y = (parseFloat(draggableElement.getAttribute('data-y')) || 0);

                    var offset = getOffset(draggableElement);
					

//                    if( !classie.has( draggableElement, 'robocong'))  by Yim 2017/10/11                      
                    if( !classie.has( draggableElement, 'botLeft') && !classie.has( draggableElement, 'botRight') && !classie.has( draggableElement, 'botUp') && !classie.has( draggableElement, 'botDown'))  //by Yim 2017/10/11                      
                    {
                        clone.style.top = (offset.top - y) +   'px';
                        clone.style.left = (offset.left - x) + 'px';
                    }
                    else
                    {
                        clone.style.top = (offset.top - y) +   'px';
						clone.style.left = (offset.left - x) + 'px';   
                    }

                    clone.position = draggableElement.position;
                    clone.style.position = 'absolute';
                    clone.style.whiteSpace = 'nowrap';
                    clone.style["z-index"] = 100;

                    document.body.appendChild(clone);

                    if( classie.has(clone, 'resize-element'))
                    {
                        clone.style["z-index"] = 10;
                        clone.style.width = 140 + 'px';
                        //classie.remove(clone, 'resize-element');
                        var children = clone.childNodes;
                        var child, leftEdge, rightEdge, columnEl;

                        for(child in children){
                            var childnode = children[child];
                            var childid = childnode.id;
                            var columnNode;

                            if(childid == 'edge1') // || childid == 'edge2') 
                            {
                                //console.log( 'edge1 ');
                                classie.add(childnode, 'toolitem');
                                classie.add(childnode, 'drag-element--dropped');    
                                childnode.style.position = 'absolute';
                                childnode.style.whiteSpace = 'nowrap';        
                            }
                            else if( childid == 'edge2' )
                            {
                                //console.log( 'edge2 ');
                                classie.add(childnode, 'toolitem');
                                classie.add(childnode, 'drag-element--dropped');                                
                                childnode.style.position = 'absolute';
                                childnode.style.whiteSpace = 'nowrap';  
                            } 
                            else if( childid == 'column' )
                            {                                
                                columnNode = childnode; 
                                childnode.style.position = 'absolute';
                                childnode.style.whiteSpace = 'nowrap';           
                                //columnNode.childNodes[1].style["visibility"] = "visible";  
                            }                            
                        }
                        clone.id = "mover" + moverIndex++;
                    }
                    else{
                        if( draggableElement.id == 'robot' )
                            clone.id = "robot" + robotIndex++;
                        else if( draggableElement.id == 'prin1' )
                            clone.id = "prin1" + printerIndex++;
                        else if( draggableElement.id == 'sensor' )
                            clone.id = "sensor" + sensorIndex++;
                        else if( draggableElement.id == 'prin2' )
                            clone.id = "prin2" + rotateIndex++;
                        else if( draggableElement.id == 'prin3' )
                            clone.id = "prin3" + soundIndex++;
                        else if( draggableElement.id == 'step1' )
                            clone.id = "step1" + step1Index++;
                        else if( draggableElement.id == 'step2' )
                            clone.id = "step2" + step2Index++;
                        else if( draggableElement.id == 'step3' )
                            clone.id = "step3" + step3Index++;
                        else if( draggableElement.id == 'step4' )
                            clone.id = "step4" + step4Index++;
                        else if( draggableElement.id == 'step5' )
                            clone.id = "step5" + step5Index++;
                        else if( draggableElement.id == 'step6' )
                            clone.id = "step6" + step6Index++;
                        else if( draggableElement.id == 'step7' )
                            clone.id = "step7" + step7Index++;
                        else if( draggableElement.id == 'step8' )
                            clone.id = "step8" + step8Index++;
                        else if( draggableElement.id == 'node1' )
                            clone.id = "node1" + node1Index++;
                        else if( draggableElement.id == 'node2' )
                            clone.id = "node2" + node2Index++;
                        else if( draggableElement.id == 'node3' )
                            clone.id = "node3" + node3Index++;
                        else if( draggableElement.id == 'node4' )
                            clone.id = "node4" + node4Index++;
                        else if( draggableElement.id == 'node5' )
                            clone.id = "node5" + node5Index++;
                        else if( draggableElement.id == 'node6' )
                            clone.id = "node6" + node6Index++;
                        else if( draggableElement.id == 'botLeft' )//by Yim 2017/10/11
                            clone.id = "botLeft" + botLeft++;//by Yim 2017/10/11
                        else if( draggableElement.id == 'botRight' )//by Yim 2017/10/11
                            clone.id = "botRight" + botRight++;//by Yim 2017/10/11
                        else if( draggableElement.id == 'botUp' )//by Yim 2017/10/11
                            clone.id = "botUp" + botUp++;//by Yim 2017/10/11
                        else if( draggableElement.id == 'botDown' )//by Yim 2017/10/11
                            clone.id = "botDown" + botDown++;//by Yim 2017/10/11

//                        console.log('new element dropped...');
						
						if( classie.has(event.target, 'edgeanchor') ) {
							event.relatedTarget.setAttribute('anchor-id', clone.id );
							
							if((clone.id=="edge1")||(clone.id=="edge2")){
							    classie.add(clone, 'makeblack');

								if(!event.target.getAttribute('FG1')){
									event.target.setAttribute('FG1', clone.parentNode.id );
								}else if(!event.target.getAttribute('FG2')){
									event.target.setAttribute('FG2', clone.parentNode.id );
								}else{ //추가된 mover가 붙지 못하도록 삭제한다.
									remove(clone.parentNode.id); return true;
								}
							}else{
								if(event.target.getAttribute('FIcon')){
									remove(event.target.getAttribute('FIcon'));
								}
								event.target.setAttribute('FIcon', clone.id );
							}

							var testG1 = event.target.getAttribute('FG1');
							var testG2 = event.target.getAttribute('FG2');

							//console.log('FG1='+testG1+'FG2='+testG2);
							//console.log( 'FIcon=' + event.target.getAttribute('FIcon') );
						}
						
	                    if(classie.has( event.target, 'disp-delbox'))
						{remove(clone.id); return true;}

											
                    }  

                    classie.add(clone, 'drag-element--dropped');     

                    revertDraggable(event.relatedTarget);    
                    //console.log( "added item's id = " + clone.id );
                }
                else
                {
					//console.log("drop"+event.target.id+" who"+event.relatedTarget.id);
                    if(classie.has( event.target, 'disp-delbox'))
					{remove(event.relatedTarget.id); return true;}
					
                    if( classie.has(event.target, 'edgeanchor') ) {
						//console.log("attatched");
						event.relatedTarget.setAttribute('anchor-id', event.target.id );
						if((event.relatedTarget.id=="edge1")||(event.relatedTarget.id=="edge2")){
						    classie.add(event.relatedTarget, 'makeblack');
							//한개의 노드에는 최대 2개의 엣지가 붙을 수 있다.
							if(!event.target.getAttribute('FG1')){
								event.target.setAttribute('FG1', event.relatedTarget.parentNode.id );
							}else if(!event.target.getAttribute('FG2')){
								event.target.setAttribute('FG2', event.relatedTarget.parentNode.id );
							}else{ //추가된 mover가 붙지 못하도록 삭제한다.
								remove(event.relatedTarget.parentNode.id); return true;
							}
						}else{
							//이미 다른 아이콘이 있다면 기존 아이콘 삭제하기
							if(event.target.getAttribute('FIcon')){
								remove(event.target.getAttribute('FIcon'));
							}
							event.target.setAttribute('FIcon', event.relatedTarget.id );
						}

						var testG1 = event.target.getAttribute('FG1');
						var testG2 = event.target.getAttribute('FG2');

						//console.log('FG1='+testG1+'FG2='+testG2);
                        //console.log( 'FIcon=' + event.target.getAttribute('FIcon') );
                    }

                    if(classie.has(event.target, 'connector'))
                    {
                        console.log('connection established...'); 

                        if( classie.has(event.relatedTarget, 'connector'))
                        {
                            classie.add(event.target, 'makeblack');
                            classie.add(event.relatedTarget, 'makeblack');
                        }
                        // save connection information...
                        if( event.target.id == 'leftconn')
                        {
                            // save mover id to toolitem object..(printer, sensor, robot...)
                            event.target.parentNode.setAttribute( 'left-conn', event.relatedTarget.parentNode.id ); // 개체의 왼쪽에 연결된 무버 아이디를 저장...
                            event.relatedTarget.parentNode.setAttribute('rightedge', event.target.parentNode.id );  // 무버의 오른쪽에 연결된 개체 아이디를 저장...

                            console.log( "moverid = " + event.target.parentNode.getAttribute('left-conn') + ', rightedge = ' + event.relatedTarget.parentNode.getAttribute('rightedge'));
                        }
                        else if( event.target.id == 'rightconn' )
                        {   
                            event.target.parentNode.setAttribute( 'right-conn', event.relatedTarget.parentNode.id ); //개체의 오른쪽에 연결된 무버 아이디를 저장...
                            event.relatedTarget.parentNode.setAttribute('leftedge', event.target.parentNode.id );  // 무버의 왼쪽에 연결된 개체 아이디를 저장...

                            console.log( "moverid = " + event.target.parentNode.getAttribute('right-conn') + ', leftedge = ' + event.relatedTarget.parentNode.getAttribute('leftedge'));
                        }
                        
                    }
                    else
                    {
                        //console.log('old element dropped...');
                    }
                }
            });
    }

    //create function, it expects 2 values.
    function insertAfter(newElement,targetElement) {
        //target is what you want it to go after. Look for this elements parent.
        var parent = targetElement.parentNode;

        //if the parents lastchild is the targetElement...
        if(parent.lastchild == targetElement) {
            //add the newElement after the target element.
            parent.appendChild(newElement);
            } else {
            // else the target has siblings, insert the new element between the target and it's next sibling.
            parent.insertBefore(newElement, targetElement.nextSibling);
            }
    }

   
    interact(document).on('ready', function () {
        transformProp = 'transform' in document.body.style
            ? 'transform': 'webkitTransform' in document.body.style
            ? 'webkitTransform': 'mozTransform' in document.body.style
            ? 'mozTransform': 'oTransform' in document.body.style
            ? 'oTransform': 'msTransform' in document.body.style
            ? 'msTransform': null;
    });

}(window.interact));
